package meerkat.bulletinboard.sqlserver.mappers;

import com.google.protobuf.ByteString;
import com.google.protobuf.InvalidProtocolBufferException;
import meerkat.protobuf.BulletinBoardAPI.BatchData;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Created by Arbel Deutsch Peled on 19-Dec-15.
 */
public class BatchDataMapper implements RowMapper<BatchData> {

    @Override
    public BatchData mapRow(ResultSet rs, int rowNum) throws SQLException {

        try {
            return BatchData.parseFrom(rs.getBytes(1));
        } catch (InvalidProtocolBufferException e) {
            return BatchData.getDefaultInstance();
        }

    }
}
