package meerkat.bulletinboard;

import com.google.protobuf.Message;
import meerkat.crypto.Digest;
import meerkat.protobuf.BulletinBoardAPI.BeginBatchMessage;
import meerkat.protobuf.BulletinBoardAPI.BatchData;

import java.util.List;


/**
 * Created by Arbel Deutsch Peled on 19-Dec-15.
 * Wrapper class for digesting Batches in a standardized way
 */
public class GenericBatchDigest implements BatchDigest{

    private Digest digest;

    public GenericBatchDigest(Digest digest) {
        this.digest = digest;
    }

    @Override
    public void update(CompleteBatch completeBatch) {

        update(completeBatch.getBeginBatchMessage());

        for (BatchData batchData : completeBatch.getBatchDataList()) {
            update(batchData);
        }

    }

    @Override
    public byte[] digest() {
        return digest.digest();
    }

    @Override
    public void update(Message msg) {
        digest.update(msg);
    }

    @Override
    public void reset() {
        digest.reset();
    }

    @Override
    public GenericBatchDigest clone() throws CloneNotSupportedException{
        return new GenericBatchDigest(digest.clone());
    }

}
